#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Raw SQL Query Tool
# DIZ: Enables you to do raw SQL queries on your database.
# GRAPHIC: ic_sql.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

if ($q->param('fct') eq "run_query") {
print "Content-type: text/plain\n\n"; 
&run_query; exit;
}


if ($q->param('fct') eq "") 
{
print "Content-type: text/html\n\n";
&start;
}


####################################################################################

sub run_query
{

$sql = $q->param('sql');
$delimiter = $q->param('delimiter');
$filename = $q->param('filename');

if ($filename ne "")
	{
	open (FLN, "> $filename") || die "Could not write to $filename";
	}


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") 
		{
		&page_top;
		print "<font face=\"Verdana\" size=\"2\"><b>SQL Syntax Error:</b> $serror <BR><BR><b>Use the back button of your browser to go back.</b></font>";
		exit;
		} 
$rows = $sth->rows(); 

if ($delimiter eq ""){ $delimiter = "\t"; }

	while ( @row = $sth->fetchrow() )
		{
		foreach $item (@row)
			{
			if ($filename ne "")
				{
				print FLN $item . $delimiter;
				}
				else
				{
				print $item . $delimiter;
				}
			}

		################
		
			if ($filename ne "")
			{
			print FLN "\n";
			}
			else
			{
			print "\n";
			}
		}

	if ($sql =~ /SELECT/i)
		{
			if ($filename ne "")
			{
			print "\n\nTOTAL RESULTS: $rows - The output has been written to" . "\n" . "$filename";
			close(FLN);
			}
			else
			{
			print "\n\nTOTAL RESULTS: $rows";
			}
		
		}
		else
		{
		print "\n$rows Rows Affected. Use the back button of your browser to go back.";
		}
	
$sth->finish;
$dbh->disconnect;

}



sub page_top
{

print <<END_OF_TP;

<table border="0" cellpadding="6" cellspacing="1" width="100%">
  <tr>
    <td width="1%" valign="top"><p align="center"><img src="$web_url/ic_sql.gif"></td>
    <td width="95%" valign="top"><font face="Arial" size="4"><strong>Raw SQL Queries</strong></font></td>
  </tr>
</table>

END_OF_TP

}




sub start
{

$hbox = acs::get_heading_box("$web_url/ic_sql.gif", "Raw SQL Queries", qq[Enables you to do raw SQL queries on your database. You will only be able to use this utility if you have basic knowledge of SQL queries.]);

print <<END_OF_ST;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>


$hbox

<form method="POST" action="$admin_url/p_rawsql.cgi">
  <input type="hidden" name="fct" value="run_query"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#DADADA">
    <tr>
      <td width="963" height="30" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>SQL
      Query </strong></td>
    </tr>
    <tr>
      <td width="963" bgcolor="#FFFFFF" class="normaltext"><textarea rows="9" name="sql" cols="62" style="width:100%"></textarea> <br>
      <strong>Examples: </strong><br>
      Select from links where title like '%sometitle%' <br>
      <strong>--or-- </strong><br>
      Select from dirs where l1 like '%business%' <br>
      <strong>--or-- <br>
      </strong>Update dirs set l1 = 'Business and Money' where l1 = 'business' </td>
    </tr>
    <tr>
      <td width="963" bgcolor="#FFFFFF" class="normaltext"><strong>If you are executing a select statement please
      specify by what you would like fields seperated by: <br>
      <input type="text" name="delimiter" size="5"> </strong>Examples: <strong>Use ; or :: or , etc... </strong></td>
    </tr>
    <tr>
      <td width="963" bgcolor="#FFFFFF" class="normaltext"><strong>If you would like the output to be written to a
      file (select queries only), provide the full server path with file name below where it
      should be written: <br>
      <input type="text" name="filename" size="62" style="width:100%"> <br>
      </strong>For example: /home/yourdomain.com/somefile.txt <br>
      If you do not provide a file name, then the output will be displayed in the browser. </td>
    </tr>
    <tr>
      <td width="963" bgcolor="#FFFFFF" class="normaltext"><input type="submit" value="Run Query" name="B1"> <br>
      Please make backups of your database before running queries that can significantly change
      data in your database. </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>



  
</form>
</body>
</html>

END_OF_ST

}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

